import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
//import org.apache.hadoop.util.GenericOptionsParser;


public class WordCount_jdwang {

	public static void main(String[] args) throws IOException, InterruptedException, ClassNotFoundException {
		
		boolean useResourceManager = true;
		
		//Step 0. Set configuration
		Configuration conf = new Configuration();	
		
		if(useResourceManager)
		{
			conf.set("fs.defaultFS", "hdfs://0.0.0.0:9000");
			conf.set("mapreduce.framework.name", "yarn");
			//conf.set("yarn.nodemanager.aux-services","mapreduce_shuffle");
			//conf.set("yarn.resourcemanager.hostname", "0.0.0.0");
			//conf.set("yarn.nodemanager.hostname", "0.0.0.0");		
		}
		else
		{
			conf.set("fs.defaultFS", "file:///");
			conf.set("mapreduce.framework.name", "local");
			//conf.set("yarn.resourcemanager.address", "localhost");
			conf.set("hadoop.tmp.dir", "/windoop/tmp/hadoop-${user.name}");
		}
	    //Job job = new Job(conf, "word count "+otherArgs[0]);
	    Job job = Job.getInstance(conf,"word count");
	    
	    job.setJarByClass(WordCount_jdwang.class);
	    job.setMapperClass(Mapper_jdwang.class);
	    
	    job.setReducerClass(Reducer_jdwang.class);
	    job.setOutputKeyClass(Text.class);
	    job.setOutputValueClass(IntWritable.class);
	    
	    FileInputFormat.addInputPath(job, new Path(args[0]));
	    
	    
	    FileSystem hdfs = FileSystem.get(conf);	    
	    Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+args[1]);
	    if(hdfs.exists(outputPath)) hdfs.delete(outputPath, true);
	    FileOutputFormat.setOutputPath(job, outputPath);
	    
	    //System.exit(job.waitForCompletion(true) ? 0 : 1);
	  
	  	job.submit();
	  		
	  	if(job.waitForCompletion(true))
	  	{
	  		System.out.println("Job Done!");
	  		System.exit(0);
	  	}
	  	else
	  	{
	  		System.out.println("Job Failed!");
	  		System.exit(1);
	  	}    
	}
}
